// All database related API calls

import { BackendQueryFormat } from '../../querybuilder';
import { Broker } from './broker';
import { QueryBuilderText } from '../store/querybuilderSlice';
import { GraphQueryResultFromBackendPayload } from '../store/graphQueryResultSlice';

export function wsQueryRequest(query: BackendQueryFormat) {
  if (query.cached === undefined) query.cached = false;
  Broker.instance().sendMessage({
    key: 'query',
    subKey: 'get',
    body: query,
  });
}

type QueryTranslationResponse = (data: QueryBuilderText) => void;
export function wsQueryTranslationSubscription(callback: QueryTranslationResponse) {
  const id = Broker.instance().subscribe(callback, 'query_translation_result');
  return () => {
    Broker.instance().unSubscribe('query_translation_result', id);
  };
}

type QueryResultResponse = (data: GraphQueryResultFromBackendPayload) => void;
export function wsQuerySubscription(callback: QueryResultResponse) {
  const id = Broker.instance().subscribe(callback, 'query_result');
  return () => {
    Broker.instance().unSubscribe('query_result', id);
  };
}
